/*
This example shows how to set up and read multiple VL53L1X sensors connected to
the same I2C bus. Each sensor needs to have its XSHUT pin connected to a
different Arduino pin, and you should change sensorCount and the xshutPins array
below to match your setup.

For more information, see ST's application note AN4846 ("Using multiple VL53L0X
in a single design"). The principles described there apply to the VL53L1X as
well.
*/

#include <Wire.h>
#include <VL53L1X.h>
#include <Arduino_PortentaBreakout.h>

VL53L1X pololu0;
VL53L1X pololu1;
VL53L1X pololu2;
VL53L1X pololu3;
VL53L1X pololu4;
VL53L1X pololu5;
VL53L1X pololu6;
VL53L1X pololu7;




breakoutPin xshut0 = PWM6; breakoutPin xshut1 = GPIO_1; breakoutPin xshut2 = GPIO_2; breakoutPin xshut3 = GPIO_0;

breakoutPin xshut4 = ANALOG_A4; breakoutPin xshut5 = PWM7; breakoutPin xshut6 = PWM8; breakoutPin xshut7 = PWM9; 


void setup()
{
  Serial.begin(115200);
  Wire.begin();
  Wire.setClock(100000); // use 400 kHz I2C

  Breakout.pinMode(xshut0,OUTPUT); //pololu0 XSHUT
  Breakout.pinMode(xshut1,OUTPUT); //pololu1 XSHUT
  Breakout.pinMode(xshut2,OUTPUT); //pololu2 XSHUT
  Breakout.pinMode(xshut3,OUTPUT); //pololu3 XSHUT
  Breakout.pinMode(xshut4,OUTPUT); //pololu0 XSHUT
  Breakout.pinMode(xshut5,OUTPUT); //pololu1 XSHUT
  Breakout.pinMode(xshut6,OUTPUT); //pololu2 XSHUT
  Breakout.pinMode(xshut7,OUTPUT); //pololu3 XSHUT
 
  
  //GPIO pinouts must be on LOW value, otherwise we will damaged the VL53L1X
  Breakout.digitalWrite(xshut0, LOW);
  Breakout.digitalWrite(xshut1, LOW);
  Breakout.digitalWrite(xshut2, LOW);
  Breakout.digitalWrite(xshut3, LOW);
  Breakout.digitalWrite(xshut4, LOW);
  Breakout.digitalWrite(xshut5, LOW);
  Breakout.digitalWrite(xshut6, LOW);
  Breakout.digitalWrite(xshut7, LOW);


 /* pololu0 */
  pinMode(xshut0, INPUT);
  if(pololu0.init())
  {
    Serial.println("pololu0 initialized");
  }
  else
  {
    Serial.println("Could not initialize pololu0");
  }

  pololu0.setAddress((uint8_t)0x40); //each pololu has to have its unique address for proper working I2C
  
  /* pololu1 */
  pinMode(xshut1, INPUT);
   if(pololu1.init())
  {
    Serial.println("pololu1 initialized");
  }
  else
  {
    Serial.println("Could not initialize pololu1");
  }
  pololu1.setAddress((uint8_t)0x41); //each pololu has to have its unique address for proper working I2C
  
 /* pololu2 */
  pinMode(xshut2, INPUT);
   delay(150);
   if(pololu2.init())
  {
    Serial.println("pololu2 initialized");
  }
  else
  {
    Serial.println("Could not initialize pololu2");
  }
   delay(150);
  pololu2.setAddress((uint8_t)0x42); //each pololu has to have its unique address for proper working I2C
  
  /* pololu3 */
  pinMode(xshut3, INPUT);
   delay(150);
   if(pololu3.init())
  {
    Serial.println("pololu3 initialized");
  }
  else
  {
    Serial.println("Could not initialize pololu3");
  }
  pololu3.setAddress((uint8_t)0x43); //each pololu has to have its unique address for proper working I2C


 /* pololu4 */
 pinMode(xshut4, INPUT);
   if(pololu4.init())
  {
    Serial.println("pololu4 initialized");
  }
  else
  {
    Serial.println("Could not initialize pololu4");
  }
  pololu4.setAddress((uint8_t)0x44); //each pololu has to have its unique address for proper working I2C
  /* pololu5 */
  pinMode(xshut5, INPUT);
   if(pololu5.init())
  {
    Serial.println("pololu5 initialized");
  }
  else
  {
    Serial.println("Could not initialize pololu5");
  }
 
  pololu5.setAddress((uint8_t)0x45); //each pololu has to have its unique address for proper working I2C

  /* pololu6 */
  pinMode(xshut6, INPUT);
   if(pololu6.init())
  {
    Serial.println("pololu6 initialized");
  }
  else
  {
    Serial.println("Could not initialize pololu6");
  }
  pololu6.setAddress((uint8_t)0x46); //each pololu has to have its unique address for proper working I2C

  /* pololu7 */
  pinMode(xshut7, INPUT);
   if(pololu7.init())
  {
    Serial.println("pololu7 initialized");
  }
  else
  {
    Serial.println("Could not initialize pololu7");
  }
  pololu7.setAddress((uint8_t)0x47); //each pololu has to have its unique address for proper working I2C

  pololu0.setDistanceMode(VL53L1X::Long);
  pololu0.setMeasurementTimingBudget(33000);
  pololu0.startContinuous(33);

  pololu1.setDistanceMode(VL53L1X::Long);
  pololu1.setMeasurementTimingBudget(33000);
  pololu1.startContinuous(33);


  pololu2.setDistanceMode(VL53L1X::Long);
  pololu2.setMeasurementTimingBudget(33000);
  pololu2.startContinuous(33);


  pololu3.setDistanceMode(VL53L1X::Long);
  pololu3.setMeasurementTimingBudget(33000);
  pololu3.startContinuous(33);


  pololu4.setDistanceMode(VL53L1X::Long);
  pololu4.setMeasurementTimingBudget(33000);
  pololu4.startContinuous(33);


  pololu5.setDistanceMode(VL53L1X::Long);
  pololu5.setMeasurementTimingBudget(33000);
  pololu5.startContinuous(33);

  pololu6.setDistanceMode(VL53L1X::Long);
  pololu6.setMeasurementTimingBudget(33000);
  pololu6.startContinuous(33);
  
  pololu7.setDistanceMode(VL53L1X::Long);
  pololu7.setMeasurementTimingBudget(33000);
  pololu7.startContinuous(33);
  
  

  
}

void loop()
{

 Serial.print("POLOLU0: ");
 Serial.print(pololu0.read());
 delay(1);
 Serial.print("    POLOLU1:");
 Serial.print(pololu1.read());
  delay(1);
 Serial.print("    POLOLU2:");
 Serial.print(pololu2.read());
  delay(1);
 Serial.print("    POLOLU3:");
 Serial.print(pololu3.read());
  delay(1);
 Serial.print("    POLOLU4:");
 Serial.print(pololu4.read());
  delay(1);
 Serial.print("    POLOLU5:");
 Serial.print(pololu5.read());
  delay(1);
 Serial.print("    POLOLU6:");
 Serial.print(pololu6.read());
  delay(1);
 Serial.print("    POLOLU7:");
 Serial.print(pololu7.read());
  delay(1);
 Serial.println();
 



 
}
